/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements. See the NOTICE file distributed with this
 * work for additional information regarding copyright ownership. The ASF
 * licenses this file to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.apithefire.servlet.server;

import org.apithefire.util.lang.Closeable;

/**
 * A server.
 * TODO: link to an example.
 * 
 * @author <a href="mailto:bachew@gmail.com">Chew Boon Aik</a>
 */
public interface Server extends Closeable {

	/**
	 * Starts this server.
	 * 
	 * @throws IllegalStateException
	 *             if this server is closed.
	 */
	public void start();
	
	/**
	 * Waits for this server to stop.
	 */
	public void join();
	
	/**
	 * Stops this server. 
	 */
	public void close();
	
}
